<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2009 Sven Burkert <sventb@googlemail.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Glossary - preselected records' for the 'a21glossary_preselected' extension.
 *
 * @author	Sven Burkert <sventb@googlemail.com>
 * @package	TYPO3
 * @subpackage	tx_a21glossarypreselected
 */
class tx_a21glossarypreselected_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_a21glossarypreselected_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_a21glossarypreselected_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'a21glossary_preselected';	// The extension key.
	var $pi_checkCHash = true;
	var $selectedGlossaryItems;
	var $detailViewPid;
	var $dontDisplayWhenCharSelected;
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
		$this->conf = $conf;
		
		$content = '';
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		if (!$this->conf['templateFile']) {
			$content .= 'Please include the template for this extension in your Main Template!';
		}
		$this->template = $this->cObj->fileResource($this->conf['templateFile']);
		$this->pi_initPIflexForm();
		$this->selectedGlossaryItems = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'glossaryItems', 'general');
		$this->detailViewPid = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'detailViewPid', 'general');
		$this->dontDisplayWhenCharSelected = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'dontDisplayWhenCharSelected', 'general');
		$a21glossaryVars = t3lib_div::_GP('tx_a21glossaryadvancedoutput_pi1');
		// do not display glossary items
		if ($this->dontDisplayWhenCharSelected && $a21glossaryVars['char']) {
			return $content;
		}
		
		$subpart = $this->cObj->getSubpart($this->template, '###TEMPLATE_MAIN###');
	
		$preselectedItems = explode(',', $this->selectedGlossaryItems);
		$markerArray['###GLOSSARY_ITEMS###'] = '';
		foreach ($preselectedItems as $glossaryId) {
			$markerArray['###GLOSSARY_ITEMS###'] .= $this->buildItem($glossaryId);
		}
		
		$content .= $this->cObj->substituteMarkerArray($subpart, $markerArray);
		return $this->pi_wrapInBaseClass($content);
	}
	
	/**
	 * Build html code for glossary item
	 * 
	 * @param integer $id: Uid of glossary item
	 * @return string: html code
	 */
	function buildItem($id) {
		$glossaryArray = $this->getGlossaryItem($id);
		$subpart = $this->cObj->getSubpart($this->template, '###TEMPLATE_ITEM###');
		$markerArray['###SHORT_WORD###'] = $glossaryArray['short'];
		$markerArray['###SHORT_TYPE###'] = '<span class="type">' . $this->pi_getLL('type.' . $glossaryArray['shorttype']) . '</span>';
		$markerArray['###LONG_VERSION###'] = $glossaryArray['longversion'];
		$markerArray['###LONG_DESCRIPTION###'] = $this->pi_RTEcssText($glossaryArray['description']);
		if ($this->detailViewPid) {
			$wrappedSubpartArray['###LINK_ITEM###'] = explode('explode-here', $this->pi_linkToPage('explode-here', $this->detailViewPid, '', array('tx_datamintsglossaryindex_pi1[uid]' => $id)));
		}
		return $this->cObj->substituteMarkerArrayCached($subpart, $markerArray, array(), $wrappedSubpartArray);
	}
	
	/**
	 * Get glossary record from database
	 * 
	 * @param integer $id: Uid of glossary item
	 * @return mixed: array or false
	 */
	function getGlossaryItem($id) {
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
			'*',
			'tx_a21glossary_main',
			'1' . $GLOBALS['TSFE']->cObj->enableFields('tx_a21glossary_main') . ' AND uid = ' . $id
		);
		return $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/a21glossary_preselected/pi1/class.tx_a21glossarypreselected_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/a21glossary_preselected/pi1/class.tx_a21glossarypreselected_pi1.php']);
}

?>